%define anolis_release 3
%define _lto_cflags %{nil}

%define majmin 5.15
%global qt_module qtdeclarative
%global __provides_exclude_from ^%{_qt5_archdatadir}/qml/.*\\.so$

Name:    qt5-%{qt_module}
Version: 5.15.11
Release: %{anolis_release}%{?dist}
Summary: Qt5 - QtDeclarative component
License: LGPLv2 with exceptions or GPLv3 with exceptions
Url:     http://www.qt.io
Source0: https://download.qt.io/official_releases/qt/%{majmin}/%{version}/submodules/%{qt_module}-everywhere-opensource-src-%{version}.tar.xz

## upstream patches
## repo: https://invent.kde.org/qt/qt/qtdeclarative
## branch: kde/5.15
## git format-patch v5.15.9-lts-lgpl
Patch0001:  0001-Remove-unused-QPointer-QQuickPointerMask.patch
Patch0002:  0002-QQmlDelegateModel-Refresh-the-view-when-a-column-is-.patch
Patch0003:  0003-Make-sure-QQuickWidget-and-its-offscreen-window-s-sc.patch
Patch0004:  0004-QQuickItem-Guard-against-cycles-in-nextPrevItemInTab.patch
Patch0005:  0005-Don-t-convert-QByteArray-in-startDrag.patch
Patch0006:  0006-Fix-build-after-95290f66b806a307b8da1f72f8fc2c698019.patch
Patch0007:  0007-Implement-accessibility-for-QQuickWidget.patch
Patch0008:  0008-Send-ObjectShow-event-for-visible-components-after-i.patch
Patch0009:  0009-QQuickItem-avoid-emitting-signals-during-destruction.patch
Patch0010:  0010-a11y-track-item-enabled-state.patch
Patch0011:  0011-Make-QaccessibleQuickWidget-private-API.patch
Patch0012:  0012-Qml-Don-t-crash-when-as-casting-to-type-with-errors.patch
Patch0015:  0015-QQmlImportDatabase-Make-sure-the-newly-added-import-.patch
Patch0016:  0016-QQuickState-when-handle-QJSValue-properties-correctl.patch
Patch0017:  0017-Models-Avoid-crashes-when-deleting-cache-items.patch

## upstreamable patches
Patch0018: 0018-%{name}-gcc11.patch
Patch0019: 0019-qtdeclarative-5.15.0-FixMaxXMaxYExtent.patch
# From: https://codereview.qt-project.org/c/qt/qtdeclarative/+/466808
Patch0020: 0020-qt-QTBUG-111935-fix-V4-jit.patch

BuildRequires: make gcc-c++ qt5-rpm-macros qt5-qtbase-devel >= %{version}
BuildRequires: qt5-qtbase-private-devel python%{python3_pkgversion}
%{?_qt5:Requires: %{_qt5} = %{_qt5_version}}

%if 0%{?tests}
BuildRequires: dbus-x11 mesa-dri-drivers time xorg-x11-server-Xvfb
%endif

Obsoletes: qt5-qtjsbackend < 5.2.0 %{name}-render2d < 5.7.1-10
%if 0%{?bootstrap}
Obsoletes: %{name}-examples < %{version}-%{release}
%global no_examples CONFIG-=compile_examples
%endif

%description
This package contains base tools, like string, xml, and network handling.

%package devel
Summary: Development files for %{name}
Obsoletes: qt5-qtjsbackend-devel < 5.2.0 %{name}-render2d-devel < 5.7.1-10
Provides:  %{name}-private-devel = %{version}-%{release}
Requires: %{name} = %{version}-%{release} qt5-qtbase-devel

%description devel
The %{name}-devel provides libraries and header files for %{name}.

%package static
Summary: Static library files for %{name}
Requires: %{name}-devel = %{version}-%{release}

%description static
The %{name}-static provides Static library files for %{name}.

%package examples
Summary: Programming examples for %{name}
Requires: %{name} = %{version}-%{release}

%description examples
The %{name}-examples provides Programming examples for %{name}.

%prep
%autosetup -n %{qt_module}-everywhere-src-%{version} -p1

%build
%ifarch riscv64
export LDFLAGS="%{_qt5_ldflags} -pthread"
%endif
ln -s %{__python3} python
export PATH=`pwd`:$PATH
%qmake_qt5
%make_build

%install
%make_install INSTALL_ROOT=%{buildroot}

mkdir %{buildroot}%{_bindir}
pushd %{buildroot}%{_qt5_bindir}
for i in * ; do
  case "${i}" in
    qmlplugindump|qmlprofiler)
      ln -v  ${i} %{buildroot}%{_bindir}/${i}-qt5
      ln -sv ${i} ${i}-qt5
      ;;
    qml|qmlbundle|qmlmin|qmlscene)
      ln -v  ${i} %{buildroot}%{_bindir}/${i}
      ln -v  ${i} %{buildroot}%{_bindir}/${i}-qt5
      ln -sv ${i} ${i}-qt5
      ;;
    *)
      ln -v  ${i} %{buildroot}%{_bindir}/${i}
      ;;
  esac
done
popd

pushd %{buildroot}%{_qt5_libdir}
for prl_file in libQt5*.prl ; do
  sed -i -e "/^QMAKE_PRL_BUILD_DIR/d" ${prl_file}
  rm -fv "$(basename ${prl_file} .prl).la"
  sed -i -e "/^QMAKE_PRL_LIBS/d" ${prl_file}
done
popd

%check
%if 0%{?tests}
export CTEST_OUTPUT_ON_FAILURE=1
export PATH=%{buildroot}%{_qt5_bindir}:$PATH
export LD_LIBRARY_PATH=%{buildroot}%{_qt5_libdir}
make sub-tests-all %{?_smp_mflags}
xvfb-run -a \
dbus-launch --exit-with-session \
time \
make check -k -C tests ||:
%endif

%files
%license LICENSE.LGPL*
%{_qt5_archdatadir}/qml/
%{_qt5_plugindir}/qmltooling/
%{_qt5_libdir}/libQt5Qml.so.5*
%{_qt5_libdir}/libQt5QmlModels.so.5*
%{_qt5_libdir}/libQt5QmlWorkerScript.so.5*
%{_qt5_libdir}/libQt5Quick.so.5*
%{_qt5_libdir}/libQt5QuickParticles.so.5*
%{_qt5_libdir}/libQt5QuickShapes.so.5*
%{_qt5_libdir}/libQt5QuickTest.so.5*
%{_qt5_libdir}/libQt5QuickWidgets.so.5*

%files devel
%{_bindir}/qml*
%{_qt5_archdatadir}/mkspecs/modules/*.pri
%{_qt5_archdatadir}/mkspecs/features/*.prf
%{_qt5_bindir}/qml*
%{_qt5_headerdir}/Qt*/
%{_qt5_libdir}/libQt5Qml.so
%{_qt5_libdir}/libQt5Qml.prl
%{_qt5_libdir}/libQt5QmlModels.so
%{_qt5_libdir}/libQt5QmlModels.prl
%{_qt5_libdir}/libQt5QmlWorkerScript.so
%{_qt5_libdir}/libQt5QmlWorkerScript.prl
%{_qt5_libdir}/libQt5Quick*.so
%{_qt5_libdir}/libQt5Quick*.prl
%{_qt5_libdir}/cmake/*
%{_qt5_libdir}/metatypes/qt5*_metatypes.json
%{_qt5_libdir}/pkgconfig/Qt5*.pc

%files static
%{_qt5_libdir}/libQt5PacketProtocol.a
%{_qt5_libdir}/libQt5PacketProtocol.prl
%{_qt5_libdir}/libQt5QmlDebug.a
%{_qt5_libdir}/libQt5QmlDebug.prl
%{_qt5_libdir}/libQt5QmlDevTools.a
%{_qt5_libdir}/libQt5QmlDevTools.prl

%if ! 0%{?no_examples:1}
%files examples
%{_qt5_examplesdir}/
%endif

%changelog
%changelog
* Sun Apr 27 2025 Shangtong Guo <guo.shangtong@zte.com.cn> - 5.15.11-3
- add support for riscv64 build

* Mon Dec 25 2023 happy_orange <songnannan@linux.alibaba.com> - 5.15.11-2
- fix the source and url error

* Wed Oct 18 2023 Funda Wang <fundawang@yeah.net> - 5.15.11-1
- New version 5.15.11

* Tue May 23 2023 Funda Wang <fundawang@yeah.net> - 5.15.9-1
- New version 5.15.9

* Tue Apr 18 2023 Heng Qi <hengqi@linux.alibaba.com> - 5.15.8-4
- Delete the 0006-Fix-TapHandler-so-that-it-actually-registers-a-tap.patch
  and 0007-Revert-Fix-TapHandler-so-that-it-actually-registers-.patch

* Fri Apr 14 2023 Jing Zhang <renyu.zj@linux.alibaba.com> - 5.15.8-3
- Refact spec

* Thu Mar 30 2023 mgb01105731 <mgb01105731@alibaba-inc.com> - 5.15.8-2
- Del Specific Fields

* Mon Jan 16 2023 Funda Wang <fundawang@yeah.net> - 5.15.8-1
- New version 5.15.8

* Wed Dec 7 2022 Funda Wang <fundawang@yeah.net> - 5.15.7-1
- New version 5.15.7

* Wed Jul 27 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> - 5.15.5-1
- init from upstream
